#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "carte.h"


/*!
* \file carte.c
* \brief Fichier contenant le code des fonctions liees aux cartes.
*/


/*!
 * \fn Carte* LireCarte(int num)
 * \brief La fonction recupere la n-ieme carte dans un fichier et renvoie un pointeur sur la carte cree
 *
 * \return Un pointeur sur une tableau de lettres.
 */
char* LireCarte(const char *filename, int num)
{
    FILE* file_map = NULL;

    char char_nb_lignes[2]="",char_nb_colonnes[2]="";
    int nb_lignes = 0, nb_colonnes = 0, i=0, j=0;
    char map[10][16];

    file_map = fopen(filename, "r");

    fseek(file_map, 5, SEEK_SET);
    (fgets(char_nb_lignes,3,file_map));
    nb_lignes = atoi(char_nb_lignes);
    fseek(file_map, 1, SEEK_CUR);
    (fgets(char_nb_colonnes,3,file_map));
    nb_colonnes = atoi(char_nb_colonnes);

    fseek(file_map, 4, SEEK_CUR);

    char * TableauCarte = NULL;
    TableauCarte = malloc(nb_colonnes * nb_lignes * sizeof(char));

    for(i=0;i<nb_colonnes;i++)
    {
        for(j=0;j<=nb_lignes;j++)
        {
            TableauCarte[nb_lignes*i+j]=fgetc(file_map);
        }
    }

    fclose(file_map);
    return TableauCarte;
}
